public class Chain
{
  private ChainItem head= new ChainItem();
  private ChainItem next= null;

  public void AddFirst(ChainItem e)
  {
    e.next= head.next;
    head.next= e;
  }

  public ChainItem FindPrev(ChainItem target)
  {
    for (ChainItem e= head; e.next!=null; e= e.next)
      if (e.next==target) return e;
    return null;
  }

  public void Catenate(ChainItem e)
  {
    ChainItem last= FindPrev(null);
    last.next= e;
  }

  public void Delete(ChainItem e)
  {
    ChainItem prev= FindPrev(e);
    if (prev==null) return;
    prev.next= e.next;
    e.next= null;
  }

  public void Raise(ChainItem e)
  {
    Delete(e);
    AddFirst(e);
  }

  public void Lower(ChainItem e)
  {
    Delete(e);
    Catenate(e);
  }

  public void Start()
  {
    next= head.next;
  }

  public ChainItem Get()
  {
    ChainItem e= next;
    if (next!=null) next= next.next;
    return e;
  }
}
