import java.net.*;
import java.io.*;

public class Download
{
  public static void main(String args[])
  {
    URL url= null;
    InputStream urlInputStream= null;

    FILE file= null;
    int skip= 0;
    long fileLastMod= 0L;

    // Check number of arguments
    if (args.length<2 || args.length>3)
      usageError("Bad number of arguments");

    // Check and get URL
    try
    { url= new URL(args[0]); }
      catch (MalformedURLException e)
      { usageError("Bad URL"); }

    // Check and get file name
    file= new FILE(args[1]);
    if (file.exists())
    {
      if (!file.isFile()) usageError("File must be a normal file");
      skip= file.length();
      fileLastMod= file.lastModified();
    }
    if (!file.canWrite()) usageError("File must be writable");

    // Check and get skip bytes
    if (args.length==3)
      try
      { int skip= Integer.parseInt(args[2]); }
      catch ( NumberFormatException e)
      { usageError("Bad format for skip bytes"); }

    // Open connection
    URLConnection connection;
    try
    { connection= url.openConnection(); }
    catch (IOException e)
    { runError("Can't open connection"); }

    // Check last modification
    // I should check for file creation date, but Java doesn't provided it.
    if (fileLastMod!=0L && fileLastMod<=connection.getLastModified())
      warning("URL has been modified since last download");

    // Get URL Input Stream
    try
    { urlInputStream= connection.getInputStream(); }
    catch (IOException e)
    { runError("Can't get stream from URL"); }

    // Open output file
