import java.awt.*;
import java.awt.event.*;

public class HiLoUI extends Frame {
  // Los mensajes

  String tituloString= "Adivina mi nmero";
  String adivinaString= "Adivina el nmero que he pensado entre 0 y 1023";
  String esMayorString= "Mi nmero es mayor que ";
  String esMenorString= "Mi nmero es menor que ";
  String adivinasteString= "Bravo! Adivinaste";
  String errorString= "Ingresa un nmero entre 0 y 1023 por favor";

  // La aplicacin
  HiLoGame hiLoGame= new HiLoGame(this);

  // Las componentes
  Label dialogoLabel= new Label(adivinaString);

  Panel eleccionPanel= new Panel();
  CardLayout eleccionLayout= new CardLayout();
  Label dimeCualLabel= new Label("Dime cul crees que es:");
  Label dimeOtroLabel= new Label("Dime otro nmero:");
  Label eraLabel= new Label("Mi nmero era:");

  TextField userNumField= new TextField("", 4);

  Label intentosLabel= new Label("Nmero de intentos:");
  TextField intentosField= new TextField("0", 4);

  Label nullLabel1= new Label("");

  Panel continuacionPanel= new Panel();
  CardLayout continuacionLayout= new CardLayout();
  Label nullLabel2= new Label("");
  Button jugarOtroButton= new Button("Jugar otra vez");

  Button terminarButton= new Button("Terminar");

  // Estado de la interaccin
  int userNum;
  int intentosNum= 0;

  // El constructor de la interfaz con el usuario
  public HiLoUI() {
    setTitle(tituloString);
    GridBagLayout layout= new GridBagLayout();
    setLayout(layout);
    GridBagConstraints constraints= new GridBagConstraints();
    constraints.insets= new Insets(5,5,5,5);

    constraints.gridwidth = GridBagConstraints.REMAINDER;
    layout.setConstraints(dialogoLabel, constraints);
    add(dialogoLabel);

    eleccionPanel.setLayout(eleccionLayout);
    eleccionPanel.add(dimeCualLabel, "dimeCual");
    eleccionPanel.add(dimeOtroLabel, "dimeOtro");
    eleccionPanel.add(eraLabel, "era");
    constraints.gridwidth= GridBagConstraints.RELATIVE;
    constraints.anchor= GridBagConstraints.WEST;
    layout.setConstraints(eleccionPanel, constraints);
    add(eleccionPanel);

    constraints.gridwidth= GridBagConstraints.REMAINDER;
    constraints.anchor= GridBagConstraints.CENTER;
    layout.setConstraints(userNumField, constraints);
    add(userNumField);

    constraints.gridwidth= GridBagConstraints.RELATIVE;
    constraints.anchor= GridBagConstraints.WEST;
    layout.setConstraints(intentosLabel, constraints);
    add(intentosLabel);

    constraints.gridwidth= GridBagConstraints.REMAINDER;
    constraints.anchor= GridBagConstraints.CENTER;
    layout.setConstraints(intentosField, constraints);
    intentosField.setEditable(false);
    add(intentosField);

    layout.setConstraints(nullLabel1, constraints);
    add(nullLabel1);

    continuacionPanel.setLayout(continuacionLayout);
    continuacionPanel.add(nullLabel2, "null");
    continuacionPanel.add(jugarOtroButton, "jugarOtro");
    constraints.gridwidth= GridBagConstraints.RELATIVE;
    layout.setConstraints(continuacionPanel, constraints);
    add(continuacionPanel);

    constraints.gridwidth= GridBagConstraints.REMAINDER;
    layout.setConstraints(terminarButton, constraints);
    add(terminarButton);

    // ActionListeners
    userNumField.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        try {
          userNum= Integer.parseInt(userNumField.getText());
          if (userNum<0 || userNum>1023) throw new NumberFormatException();
          intentosNum++;
          intentosField.setText(""+intentosNum);
          hiLoGame.userSays(userNum);
        }
        catch (NumberFormatException excp) {
          dialogoLabel.setText(errorString);
        }
      }
    } );

    terminarButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        System.exit(0);
      }
    } );

    jugarOtroButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        dialogoLabel.setText(adivinaString);
        eleccionLayout.show(eleccionPanel, "dimeCual");
        continuacionLayout.show(continuacionPanel,"null");
        hiLoGame= new HiLoGame(HiLoUI.this);
        userNumField.setEditable(true);
        userNumField.setText("");
        intentosNum= 0;
        intentosField.setText("0");
      }
    } );
  }

  public void isLower() {
    eleccionLayout.show(eleccionPanel, "dimeOtro");
    dialogoLabel.setText(esMayorString+userNum);
    userNumField.setText("");
  }

  public void isGreater() {
    eleccionLayout.show(eleccionPanel, "dimeOtro");
    dialogoLabel.setText(esMenorString+userNum);
    userNumField.setText("");
  }

  public void success() {
    eleccionLayout.show(eleccionPanel, "era");
    dialogoLabel.setText(adivinasteString);
    userNumField.setEditable(false);
    continuacionLayout.show(continuacionPanel,"jugarOtro");
  }

  public static void main(String[] args) {
    Frame frame= new HiLoUI();
    frame.pack();
    frame.show();
  }
}
