public abstract class GenSorter {

  // El algoritmo de ordenamiento
  public void sort() {
    quicksort(0, size()-1);
  }
  
  void quicksort(int i, int j) {
    if (i>=j)
      return; 
    int k= particionar(i, j);
    quicksort(i, k-1);
    quicksort(k+1, j);
  }
  
  int particionar(int i, int j) {
    int k= i; 
    i++;
    for(;;) {
      while (i<j && compare(i,k)<=0)
        i++;
      while (i<j && compare(j,k)>=0)
        j--;
      if (i==j)
        break;
      swap(i,j);
    }
    if (compare(k,i)<0)
      i--;
    swap(k,i);
    return i;
  }

  // Redefina este metodo para que particionar pueda intercambiar
  // dos elementos.
  // Un metodo abstracto no necesita implementacion
  // Esta ahi para que sea redefenido en una subclase
  public abstract void swap(int i, int j);

  // Redefina este metodo para que Sorter pueda comparar dos elementos
  // Retorne -1 (menor), 0 (igual) o 1 (mayor)
  public abstract int compare(int i, int j);

  // Redefina este metodo para que Sorter pueda obtener el taman~o del arreglo
  public abstract int size();

  // Redefina este metodo para desplegar en pantalla el arreglo
  public abstract void print();
}
