#!/usr/bin/perl
#
# slides - make html slides from a big HTM file
#
# Use: slides root
#
# Reads from file "root.htm", and outputs files of the form "root/pageNN.htm"
# Also copy to "root/" all files requested via "<img src=" and "<a href=".

die "Use: slides root" unless $#ARGV == 0;
$root = $ARGV[0];
$dir = "." . $root;
open(IN,"Html/" . $root . ".htm") || die "Can't open input file $root.htm";
-d($dir) || mkdir($dir,0777) || die "Can't find or make directory $dir";
chdir $dir;

while(<IN>)
  {
	last if /^<!--cut here-->/;
	$header .= $_;
  }
exit unless $_;

$thispage=0;
$inexample=0;

while('true')
  {
	if( /^<!--example-->/ )
	  {
		print PAGE "<pre>\n";
		$inexample=1;
		next;
	  }
	elsif ( /^<!--\/example-->/ )
	  {
		print PAGE "</pre>\n";
		print PAGE '<table border=0 width=100%><tr><td align=right>[<a href="',
			sprintf("ex%02d.htm",$thispage),
			'">Preview</a>]</td></tr></table>', "\n";
		$inexample=0;
		next;
	  }
	elsif( /^<!--perl-->/ )
	  {
		print PAGE "<center><table border=2><tr><td><pre>\n";
		$inexample=1;
		$pgmfile = sprintf("pgm%02d",$thispage);
		open(EX,">$pgmfile")
			|| die "Can't open perl example file";
		chmod 0755, $pgmfile;
		next;
	  }
	elsif( /^<!--\/perl-->/ )
	  {
		print PAGE "</pre></td></tr></table></center>\n";
		$inexample=0;
		next;
	  }
	elsif( (!$_ || /^<!--cut here-->/) && $thispage>0 )
	  {
                print PAGE "<hr>\n";
                print PAGE '<a href="page',
                        sprintf("%02d", $thispage-1),
                        '.htm"><img src="../images/prevpage.gif" align=left></a>',"\n"
                        if $thispage>1;
                print PAGE '<a href="page',
                        sprintf("%02d", $thispage+1),
                        '.htm"><img src="../images/nextpage.gif" align=right></a>',"\n"
                        if $_;
                print PAGE "<center>- $thispage -</center>\n</body>\n</html>\n";
	  }
	last unless $_;
	if(/^<!--cut here-->/)
	  {
		++$thispage;
		open(PAGE, sprintf(">page%02d.htm",$thispage))
			|| die "Can't open page file";
		$_ = $header;
	  }
	if( $inexample )
	  {
		s/&/&amp;/g;
		s/</\&lt;/g;
	  }
	print PAGE;

	while( /(img src|a href)="([\w\-.]+)["\#]/ig )
	  {
		$auxfile = "../$2";
		if( -r $auxfile )
		  {
			system( "echo cp $auxfile ." );
		  }
	  }
  }
continue
  {
	$_ = <IN>;
  }
